﻿/* Signalr Handler*/

var $hubConnected = false;
$(function () {
    var fmHub = $.connection.fileManagerHub;
    $.extend(fmHub.client, {
        OnUpdateProgress: function (strFileName, nPercentage) {
            lblEncryptionStatus.SetText(strFileName);
            progress3.SetPosition(nPercentage);
        },
        OnProcessingComplete: function ($error) {
            if ($error == "") {
                pcProgress.Hide();
                FileManager.PerformCallback({ strCommand: 'folder_refresh' });
                if ($arrFilesUploaded != undefined) {
                    if ($arrFilesUploaded.length > 0) {
                        $fileNames = "";
                        for (i = 0; i < $arrFilesUploaded.length; i++) {
                            $fileNames += $arrFilesUploaded[i] + "<br/>";
                        }
                        $workspaceName = $workspaceAfterFileAddition;
                        $m_WorkgroupMemberList = "";
                        arrCurrentMembers = $membersListAfterFileAddition.split(';');
                        for (i = 0; i < arrCurrentMembers.length; i++) {
                            if (arrCurrentMembers[i] != $myIdentity) {
                                if ($m_WorkgroupMemberList != "") {
                                    $m_WorkgroupMemberList += ";";
                                }
                                $m_WorkgroupMemberList += arrCurrentMembers[i];
                            }
                        }
                        if ($m_WorkgroupMemberList != "") {
                            m_strNotifySubject = fnGetSubjectFromTemplate(3, $workspaceName, "", "", $workspaceName.replace("Workspaces\\", ""), "");
                            m_strNotifyBody = fnGetBodyFromTemplate(3, $workspaceName, "", $WorkspaceURL, $workspaceName.replace("Workspaces\\", ""), $fileNames);
                            $("#confirmationMessage").html("Do you want to send an email to all the members since you have uploaded/added new files?");
                            $showNotificationConfirmation = true;
                        }
                    }
                }
                if ($toon != undefined) {
                    $toon = true;
                }

            }
            else {
                fileUploadErrorMessage.SetText($error);
            }

            uploadControlButton.ClearText();
        }
    });
    // Start the connection.
    $.connection.hub.start().done(function () {        
        $hubConnected = true;
    });

    $.connection.hub.disconnected(function () {
        $hubConnected = false;
        setTimeout(function () {
            $.connection.hub.start().done(function () {
                $hubConnected = true;
            });
        }, 1000); // Restart connection after 5 seconds.
    });
});

function fnProcessFileUpload($folderid) {
    if ($hubConnected == false) {
        $.connection.hub.start().done(function () {
            $hubConnected = true;
            var fmHub = $.connection.fileManagerHub;
            fmHub.server.fnProcessFileUpload($folderid);
        });
    }
    else {
        var fmHub = $.connection.fileManagerHub;
        fmHub.server.fnProcessFileUpload($folderid);
    }
    
}