﻿let apiBaseUrl = '/api/';
let documentId = '';
let ratio = 1;
let canvasHeight = 760;
let canvasWidth = 2000;
let currentPage = 1;
let Npages = [];
let aRatio = [];
let dataLoad;
let shapes = [];
let shapes2 = [];
let Attachments = [];
let fontText = 'Arial';
let fontSize = 12;
let fontWeight = '';
let fontStyle = '';
let fontColor = 'black';
let mouseX;
let mouseY;
let textX;
let textY;
let editText = -1;
let imageObj;
let selectedShape = -1;
let searchFolder = '';
let pageHeights = {};
let heights;
let currentTools = 'reading';
let anchorVal = -1;
let signX = 5;
let signY = 5;
let r = 0;
let isDown = false;
let isDocumentEdited = false;
// The active tool instance.
let tool;
let tool_default;
var tools = {};
var bHasUnsavedChanges = false;

let documentClosed = false;

let bClosedUsingButton = false;
let newX = "";
let newY = "";
let newheight = "";
function alertModal(msg, xhr, textStatus, error) {
    if (xhr != null && xhr.responseJSON != null) {
        msg += xhr.responseJSON.detail;
    }

    if (error != null) {
        msg += error;
    }


    alert(textStatus + " error" + msg);
}

// Keep everything in anonymous function, called on window load.
if (window.addEventListener) {
    window.addEventListener('load', function () {
        //this should suppress session timeout
        $toon = false;
        let canvas, context, canvaso, contexto;

        let tempX;
        let tempY;
        let tempW;
        let tempH;
        let numShapes = 0;
        let dragIndex=0;
        let dragging;

        let dragHoldX;
        let dragHoldY;
        canvasWidth = 1138;
        canvasHeight = 760;

        //$('#loadingModal').modal('show');
        LoadingPanel.Show();
        var strFolderPath = $('#strFolderPath').val();
        var p1 = strFolderPath;
        var p = p1.replace(/\\/g, "/");
        if (p.charAt(0) == '/') {
            p = p.substr(1);
        }
        fnSendWsUpdate(p);
        
        function init() {    
            // Find the canvas element.
            canvaso = document.getElementById('imageView');
            canvaso.width = canvasWidth;
            canvaso.height = canvasHeight;

            tempX = 0;
            tempY = 0;
            tempW = 0;
            tempH = 0;
            tool_default = 'reading';

            if (!canvaso) {
                alertModal('Error: I cannot find the canvas element!');
                return;
            }

            if (!canvaso.getContext) {
                alertModal('Error: no canvas.getContext!');
                return;
            }

            // Get the 2D canvas context.
            contexto = canvaso.getContext('2d');

            if (!contexto) {
                alertModal('Error: failed to getContext!');
                return;
            }

            // Add the temporary canvas.
            var container = canvaso.parentNode;
            canvas = document.createElement('canvas');
            if (!canvas) {
                alertModal('Error: I cannot create a new canvas element!');
                return;
            }

            canvas.id = 'imageTemp';
            canvas.display = 'none';
            canvas.width = canvaso.width;
            canvas.height = canvaso.height;
            container.appendChild(canvas);
            context = canvas.getContext('2d');

            // Activate the default tool.
            if (tools[tool_default]) {
                tool = new tools[tool_default]();

            }

            // Attach the mousedown, mousemove and mouseup event listeners.
            canvaso.addEventListener('mousedown', ev_canvas, false);
            canvaso.addEventListener('mousemove', ev_canvas, false);
            canvaso.addEventListener('mouseup', ev_canvas, false);
            $(".PreviousPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_left_arrow_disabled");
            $(".btnDrag .dxm-image").removeClass().addClass("dx-vam dxm-image ws_icon_delete_access_disabled");
            $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_disabled");
            fileSelectedOnload();
            
            //GetFileExists();

        }

        function ev_canvas(ev) {
            if (ev.layerX || ev.layerX === 0) { // Firefox
                ev._x = ev.layerX;
                ev._y = ev.layerY;
            } else if (ev.offsetX || ev.offsetX === 0) { // Opera
                ev._x = ev.offsetX;
                ev._y = ev.offsetY;
            }
            // Call the event handler of the tool.
            let func = tool[ev.type];
            if (func) {
                func(ev);
            }
        }

        // This object holds the implementation of each drawing tool.


        // The rectangle tool.
        tools.rect = function () {
            let tool = this;
            this.started = false;
            this.mousedown = function (ev) {
                if (currentTools === 'Rect') {
                    tool.started = true;
                    tool.x0 = ev._x;
                    tool.y0 = ev._y;
                }
            };
            this.mousemove = function (ev) {
                if (!tool.started) {
                    return;
                }

                var x = Math.min(ev._x, tool.x0),
                    y = Math.min(ev._y, tool.y0),
                    w = Math.abs(ev._x - tool.x0),
                    h = Math.abs(ev._y - tool.y0);

                context.clearRect(0, 0, canvas.width, canvas.height);

                if (!w || !h) {
                    return;
                }

                context.fillStyle = 'rgba(255, 230, 81, 0.5)';
                context.fillRect(x, y, w, h);

                tempX = x;
                tempY = y;
                tempW = w;
                tempH = h;
                numShapes = numShapes + 1;

            };
            this.mouseup = function (ev) {
                if (tool.started) {
                    tool.mousemove(ev);
                    tool.started = false;
                    img_update();
                    tempShape = {
                        x: tempX,
                        y: tempY,
                        textWidth: tempW,
                        fontHeight: tempH,
                        page: currentPage,
                        f: Npages[currentPage - 1],
                        text: '',
                        fontText: '',
                        fontSize: '',
                        fontColor: '',
                        fontWeight: '',
                        fontStyle: '',
                        ratio: aRatio[currentPage - 1],
                        imfile: '',
                        imName: '',
                        Itype: 'highlight',
                        fieldType: '',
                        fieldName: '',
                        fieldLLX: '',
                        fieldLLY: ''
                    };
                    shapes.push(tempShape);
                }
            };
        };

        // The signature tool.

        // The reading tool.
        tools.reading = function () {
            tool = this;
            this.started = false;
        };


        // The reading tool.
        tools.dragging = function () {
            tool = this;
            this.started = false;
            // canvas.addEventListener("mousedown", mouseDownListener, false);
            this.mousedown = function (ev) {
                if (currentTools === 'Drag') {
                    tool.started = true;
                    tool.x0 = ev._x;
                    tool.y0 = ev._y;

                    var i;
                    //We are going to pay attention to the layering order of the objects so that if a mouse down occurs over more than object,
                    //only the topmost one will be dragged.
                    var highestIndex = -1;

                    //getting mouse position correctly, being mindful of resizing that may have occured in the browser:
                    let bRect = canvas.getBoundingClientRect();
                    mouseX = (ev.clientX - bRect.left) * (canvas.width / bRect.width);
                    mouseY = (ev.clientY - bRect.top) * (canvas.height / bRect.height);

                    //find which shape was clicked
                    for (i = 0; i < shapes.length; i++) {
                        

                        if (hitTest(shapes[i], mouseX, mouseY, context)) {

                         
                           
                            var maxWidth = context.canvas.width - mouseX;;
                            //wrapText(context, shapes[i].text, mouseX, mouseY, maxWidth, 25)

                            if (anchorHitTest(shapes[i], mouseX, mouseY, context) === -1) {
                                dragging = true;
                                anchorVal = -1;
                                isDown = false;
                            }
                            else {

                                if (shapes[i].Itype === 'image') {
                                    dragging = false;
                                    isDown = false;
                                }
                                else if (shapes[i].Itype === 'text' && anchorVal === 5) {

                                    dragging = false;
                                    isDown = true;
                                }
                                else {
                                    dragging = true;
                                    anchorVal = -1;
                                    isDown = false;
                                }
                            }
                            selectedShape = i;
                            if (i > highestIndex) {
                                //We will pay attention to the point on the object where the mouse is "holding" the object:
                                dragHoldX = mouseX - shapes[i].x;
                                dragHoldY = mouseY - shapes[i].y;
                                highestIndex = i;
                                dragIndex = i;

                                var rect = canvas.getBoundingClientRect();


                                if (shapes[dragIndex].Itype !== 'text') {
                                    contexto.strokeStyle = 'brown';
                                    contexto.setLineDash([6]);
                                    contexto.strokeRect(shapes[dragIndex].x, shapes[dragIndex].y, shapes[dragIndex].textWidth, shapes[dragIndex].fontHeight);
                                }


                                if (shapes[dragIndex].Itype === 'image') {
                                    context.fillStyle = 'rgba(255, 230, 81, 1)';
                                    context.fillRect(shapes[dragIndex].x, shapes[dragIndex].y, 10, 10);
                                    context.fillRect(shapes[dragIndex].x + shapes[dragIndex].textWidth - 10, shapes[dragIndex].y, 10, 10);
                                    context.fillRect(shapes[dragIndex].x, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);
                                    context.fillRect(shapes[dragIndex].x + shapes[dragIndex].textWidth - 10, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);

                                }
                                else if (shapes[dragIndex].Itype === 'text') {
                                    //drawRotationHandle(shapes[dragIndex], context);
                                }

                                mouseX = ev.pageX - canvas.offsetLeft;
                                mouseY = ev.pageY - canvas.offsetTop;

                                $('#divDel').css('visibility', 'visible');
                                $('#divDel').css('left', rect.left + shapes[dragIndex].x - 50);
                                if (rect.top < 0) {
                                    $('#divDel').css('top', mouseY);
                                }
                                else
                                {
                                    $('#divDel').css('top', rect.top + shapes[dragIndex].y);
                                   
                                }

                                break;
                            }
                        }
                        else {
                            $('#divDel').css('visibility', 'hidden');
                            document.getElementById('imageView').getContext('2d').width = document.getElementById('imageTemp').getContext('2d').width;
                            //DrawScreen();
                            //DrawShapes();
                        }
                    }

                    //code below prevents the mouse down from having an effect on the main browser window:
                    if (ev.preventDefault) {
                        ev.preventDefault();
                    } //standard
                    else if (ev.returnValue) {
                        ev.returnValue = false;
                    }

                    //older IE
                    return false;
                }
            };

            //this.mousemove = function (evt) {
            //    if (!tool.started) {
            //        return;
            //    }

            //    if (dragging) {

            //        var posX;
            //        var posY;
            //        //getting mouse position correctly 
            //        var bRect = canvas.getBoundingClientRect();
            //        mouseX = (evt.clientX - bRect.left) * (canvas.width / bRect.width);
            //        mouseY = (evt.clientY - bRect.top) * (canvas.height / bRect.height);

            //        //clamp x and y positions to prevent object from dragging outside of canvas
            //        posX = mouseX - dragHoldX;

            //        posY = mouseY - dragHoldY;

            //        var newposX = posX;
            //        var newposY = posY;

            //        if (posX < 0) {
            //            newposX = 0;
            //        }
            //        if (posX + shapes[dragIndex].textWidth > context.canvas.width) {
            //            newposX = posX - shapes[dragIndex].textWidth;
            //        }
            //        if (posY < bRect.top) {
            //            newposY = bRect.top;
            //        }
            //        if (newposY + shapes[dragIndex].fontHeight > context.canvas.height) {
            //            newposY = context.canvas.height - shapes[dragIndex].fontHeight;
            //        }


            //        shapes[dragIndex].x = newposX;
            //        shapes[dragIndex].y = newposY;

            //        canvas.width = canvas.width;

            //        DrawScreen();

            //        DrawShapes();

            //        mouseX = evt.pageX - canvas.offsetLeft;
            //        mouseY = evt.pageY - canvas.offsetTop;
                   

            //        if (shapes[dragIndex].Itype !== 'text') {
            //            context.strokeStyle = 'brown';
            //            context.setLineDash([6]);
            //            context.strokeRect(shapes[dragIndex].x, shapes[dragIndex].y, shapes[dragIndex].textWidth, shapes[dragIndex].fontHeight);
            //        }
            //        if (shapes[dragIndex].Itype === 'image') {

            //            context.fillStyle = 'rgba(255, 230, 81, 1)';
            //            context.fillRect(shapes[dragIndex].x, shapes[dragIndex].y, 10, 10);
            //            context.fillRect((shapes[dragIndex].x + shapes[dragIndex].textWidth) - 10, shapes[dragIndex].y, 10, 10);
            //            context.fillRect(shapes[dragIndex].x, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);
            //            context.fillRect((shapes[dragIndex].x + shapes[dragIndex].textWidth) - 10, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);

            //        }
            //        else if (shapes[dragIndex].Itype === 'text') {

            //            //drawRotationHandle(shapes[dragIndex], context);

            //        }

            //        $('#divDel').css('visibility', 'hidden');

            //    }

            //    else if (isDown) {
            //        let posX;
            //        let posY;
            //        //getting mouse position correctly 
            //        let bRect = canvas.getBoundingClientRect();
            //        mouseX = (evt.clientX - bRect.left) * (canvas.width / bRect.width);
            //        mouseY = (evt.clientY - bRect.top) * (canvas.height / bRect.height);

            //        //clamp x and y positions to prevent object from dragging outside of canvas
            //        posX = mouseX - dragHoldX;

            //        posY = mouseY - dragHoldY;

            //        var dx = mouseX - shapes[dragIndex].x + (shapes[dragIndex].textWidth) / 2;
            //        var dy = mouseY - shapes[dragIndex].y + (shapes[dragIndex].fontHeight) / 2;
            //        var angle = Math.atan2(dy, dx);
            //        r = angle;

            //        shapes[dragIndex].fieldType = r;

            //        DrawScreen();
            //        DrawShapes();
            //        //drawRotationHandle(shapes[dragIndex], context);

            //    }
            //    else {

            //        let posX;
            //        let posY;
            //        //getting mouse position correctly 
            //        let bRect = canvas.getBoundingClientRect();
            //        mouseX = (evt.clientX - bRect.left) * (canvas.width / bRect.width);
            //        mouseY = (evt.clientY - bRect.top) * (canvas.height / bRect.height);

            //        //clamp x and y positions to prevent object from dragging outside of canvas
            //        posX = mouseX - dragHoldX;
            //        posY = mouseY - dragHoldY;

            //        imgWidth = (shapes[dragIndex].x + shapes[dragIndex].textWidth);
            //        imgHeight = (shapes[dragIndex].y + shapes[dragIndex].fontHeight);

            //        // resize the image
            //        switch (anchorVal) {
            //            case 0:
            //                //top-left
            //                shapes[dragIndex].x = posX;
            //                shapes[dragIndex].y = posY;
            //                shapes[dragIndex].textWidth = imgWidth - posX;
            //                shapes[dragIndex].fontHeight = imgHeight - posY;
            //                break;
            //            case 1:
            //                //top-right
            //                shapes[dragIndex].y = posY;
            //                shapes[dragIndex].textWidth = shapes[dragIndex].textWidth - (imgWidth - mouseX);
            //                shapes[dragIndex].fontHeight = imgHeight - posY;
            //                break;
            //            case 2:
            //                //bottom-right
            //                shapes[dragIndex].x = posX;
            //                shapes[dragIndex].textWidth = imgWidth - posX;
            //                shapes[dragIndex].fontHeight = shapes[dragIndex].fontHeight - (imgHeight - mouseY);
            //                break;
            //            case 3:
            //                //bottom-left
            //                shapes[dragIndex].textWidth = shapes[dragIndex].textWidth - (imgWidth - mouseX);
            //                shapes[dragIndex].fontHeight = shapes[dragIndex].fontHeight - (imgHeight - mouseY);
            //                break;

            //        }


            //        if (shapes[dragIndex].textWidth < 25) { shapes[dragIndex].textWidth = 25; }
            //        if (shapes[dragIndex].fontHeight < 25) { shapes[dragIndex].fontHeight = 25; }

            //        canvas.width = canvas.width;


            //        DrawScreen();

            //        DrawShapes();

            //        if (shapes[dragIndex].Itype !== 'text') {
            //            context.strokeStyle = 'brown';
            //            context.setLineDash([6]);
            //            context.strokeRect(shapes[dragIndex].x, shapes[dragIndex].y, shapes[dragIndex].textWidth, shapes[dragIndex].fontHeight);
            //        }
            //        else if (shapes[dragIndex].Itype === 'text') {

            //            //drawRotationHandle(shapes[dragIndex], context);

            //        }
            //        if (shapes[dragIndex].Itype === 'image') {

            //            context.fillStyle = 'rgba(255, 230, 81, 1)';
            //            context.fillRect(shapes[dragIndex].x, shapes[dragIndex].y, 10, 10);
            //            context.fillRect((shapes[dragIndex].x + shapes[dragIndex].textWidth) - 10, shapes[dragIndex].y, 10, 10);
            //            context.fillRect(shapes[dragIndex].x, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);
            //            context.fillRect((shapes[dragIndex].x + shapes[dragIndex].textWidth) - 10, (shapes[dragIndex].y + shapes[dragIndex].fontHeight) - 10, 10, 10);

            //        }

            //        mouseX = evt.pageX - canvas.offsetLeft;
            //        mouseY = evt.pageY - canvas.offsetTop;

            //        $('#divDel').css('visibility', 'hidden');

            //    }

            //};
            this.mouseup = function (evt) {
                if (tool.started) {
                    tool.started = false;
                }
                isDown = false;
                if (dragging) {
                    var rect = canvas.getBoundingClientRect();
                    $('#divDel').css('visibility', 'visible');
                    $('#divDel').css('left', rect.left + shapes[dragIndex].x - 50);
                   // $('#divDel').css('top', rect.top + shapes[dragIndex].y);
                    if (rect.top < 0) {
                        $('#divDel').css('top', mouseY);
                    }
                    else {
                        $('#divDel').css('top', rect.top + shapes[dragIndex].y);
                    }
                    dragging = false;


                }
            };
        };

        // Testing
        // The reading tool.
        tools.texting = function () {
            let tool = this;
            this.started = false;
            this.mousedown = function (ev) {

                if (currentTools === 'Text') {
                    tool.started = true;
                    tool.x0 = ev._x;
                    tool.y0 = ev._y;

                    textX = ev._x;
                    textY = ev._y;

                    textareaTest.SetText('');
                    fontText = 'Arial';
                    fontSize = 12;
                    ddSize.SetText(fontSize);
                    ddFont.SetText(fontText);
                    //find which shape was clicked
                    for (i = 0; i < shapes.length; i++) {
                        if (shapes[i].text !== '') {

                            if (hitTest(shapes[i], textX, textY, context)) {
                                if (currentPage == shapes[i].page) {
                                    editText = i;
                                    textareaTest.SetText(shapes[i].text);
                                    fontSize = shapes[i].fontSize;
                                    fontText = shapes[i].fontText;
                                    ddSize.SetText(fontSize);
                                    ddFont.SetText(fontText);
                                    break;
                                }
                                else {
                                    editText = -1;
                                }
                            }
                            else {
                                editText = -1;
                                fontText = 'Arial';
                                fontSize = 12;
                                ddSize.SetText(fontSize);
                                ddFont.SetText(fontText);
                            }
                        }
                    }

                    mouseX = textX;
                    mouseY = textY;
                    textAreaPopUp.ShowAtPos(ev.screenX, ev.screenY);
                    //$('#textAreaPopUp').css('visibility', 'visible');

                    textAreaPopUp.Show();

                    //$('#textAreaPopUp').css('left', mouseX);
                    //$('#textAreaPopUp').css('top', mouseY);
                    var editor = $('#textareaTest');
                    editor.focus();
                }
            };

            this.mousemove = function (evt) {
                if (!tool.started) {
                    return;
                }
            };

            this.mouseup = function (evt) {
                if (tool.started) {
                    tool.started = false;
                }
                if (dragging) {
                    dragging = false;
                }
            };

        };

        init();

    }, false);

}
function hitTest(shape, mx, my, context) {

    if (shape.Itype === 'text') {

        context.save();

        context.translate(shape.x, shape.y + parseInt(shape.fontSize));
        context.rotate(shape.fieldType);

        context.beginPath();
        context.rect(0, -shape.fontHeight, shape.textWidth + 5, shape.fontHeight);

        var result = context.isPointInPath(mx, my);

        context.restore();

        return result;
    }

    if (mx > shape.x && mx < shape.x + shape.textWidth) {
        if (my > shape.y && my < shape.y + shape.fontHeight) {
            return true;
        }
        else {

            return false;
        }
    }
    else {

        return false;
    }
}


function getTextWidth(text, fontStyle, fontWeight, fontText, fontSize) {
    // Create a temporary canvas
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');

    ctx.font = fontStyle + ' ' + fontWeight + ' ' + fontSize + 'px ' + fontText;
    // Set the font on the temporary context
    //ctx.font = font;

    // Measure the width of the text on the temporary canvas
    var txtwidth = ctx.measureText(text).width;

    // Return the width
    return txtwidth;
}



function getTextHeight(lines, lineHeight) {
    // Create a temporary canvas
    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');
    lines = lines.split('\n');
    var totalHeight = lines.length * lineHeight;
    console.log("totalHeight :" + totalHeight);
   
    // Return the width
    return totalHeight;
}
function saveTextFromArea() {


    console.log("in saveTextFromArea");
    try {

        var validateText = OnNameValidation();
        if (validateText == "valid") {


            var item = Pdfmenu.GetItemByName("Drag");
            item.SetEnabled(true);
            $(".btnDrag .dxm-image").removeClass().addClass("dx-vam dxm-image ws_icon_delete_access_normal");
            var item = Pdfmenu.GetItemByName("SaveChanges");
            item.SetEnabled(true);
            $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_normal");
            bHasUnsavedChanges = true;
            //get the value of the textarea
            var text = textareaTest.GetValue();

            if (shapes.length == 0) {
                editText = -1;
            }
            if (text !== '' && text != null) {
                r = 0;
                var canvas = document.getElementById('imageView');
                var ctx = canvas.getContext('2d');

                if (editText === -1) {
                    /*var maxWidth = 400;*/
                    var lineHeight = 25;
                    //set the font styles
                    ctx.fillStyle = fontColor;

                    //draw the text
                    ctx.font = fontStyle + ' ' + fontWeight + ' ' + fontSize + 'px ' + fontText;
                    // Calculate the width of the text
                    var calwidth = getTextWidth(text, fontStyle, fontWeight, fontText, fontSize);
                    var calHeight = getTextHeight(text, lineHeight);

                    if ((textX + calwidth) > ctx.canvas.width) {
                        //alert("Please add text at other location")  
                        lblPolicyMessage.SetVisible(true);
                        lblPolicyMessage.SetText(pdf_error_message);
                    }
                    else {
                        if ((textY + calHeight) > ctx.canvas.height) {
                            //alert("Please add text at other location")
                            lblPolicyMessage.SetVisible(true);
                            lblPolicyMessage.SetText(pdf_error_message);
                        }
                        else {
                            ctx.fillText(text, textX, textY + parseInt(fontSize));
                            //console.log("width: " + ctx.measureText(text).width);
                            tempShape = {
                                x: textX,
                                y: textY,
                                textWidth: ctx.measureText(text).width,
                                fontHeight: parseInt(fontSize),
                                page: currentPage,
                                f: Npages[currentPage - 1],
                                text: text,
                                fontText: fontText,
                                fontSize: fontSize,
                                fontColor: fontColor,
                                fontWeight: fontWeight,
                                fontStyle: fontStyle,
                                ratio: aRatio[currentPage - 1],
                                imfile: '',
                                imName: '',
                                Itype: 'text',
                                fieldType: r,
                                fieldName: '',
                                fieldLLX: '',
                                fieldLLY: ''
                            };

                            shapes.push(tempShape);
                            ctx.save();
                            ctx.restore();
                            textAreaPopUp.Hide();
                        }
                    }

                }
                else {
                    /*var maxWidth = 400;*/
                    var lineHeight = 25;
                    //set the font styles
                    ctx.fillStyle = fontColor;

                    //draw the text
                    ctx.font = fontStyle + ' ' + fontWeight + ' ' + fontSize + 'px ' + fontText;
                    // Calculate the width of the text
                    var calwidth = getTextWidth(text, fontStyle, fontWeight, fontText, fontSize);
                    var calHeight = getTextHeight(text, lineHeight);

                    if ((textX + calwidth) > ctx.canvas.width) {
                        lblPolicyMessage.SetVisible(true);
                        //alert("Please add text at other location")
                        lblPolicyMessage.SetText(pdf_error_message);
                        //wrapText(ctx, text, textX, textY, maxWidth, lineHeight);

                        //drawWrappedText(ctx, text, textX, textY, lineHeight, maxWidth, maxHeight);

                        //newWidth =ctx.canvas.width - newX;

                    }
                    else {

                        if ((textY + calHeight) > ctx.canvas.height) {
                            //alert("Please add text at other location")
                            lblPolicyMessage.SetVisible(true);
                            lblPolicyMessage.SetText(pdf_error_message);
                        }
                        else {
                            if (shapes.length > 0) {
                                //shapes[editText].x = textX;
                                //shapes[editText].y = textY;
                                shapes[editText].text = text;
                                shapes[editText].fontWeight = fontWeight;
                                shapes[editText].fontSize = fontSize;
                                shapes[editText].fontText = fontText;
                                shapes[editText].fontStyle = fontStyle;
                                shapes[editText].fontColor = fontColor;
                                shapes[editText].fontHeight = parseInt(fontSize);

                                DrawScreen();
                                DrawShapes();
                                shapes[editText].textWidth = ctx.measureText(text).width;
                                ctx.save();
                                ctx.restore();
                                textAreaPopUp.Hide();
                            }
                        }
                    }
                }

            }
        }
        else {
            lblPolicyMessage.SetText(validateText);
            lblPolicyMessage.SetVisible(true);
        }
    }
    catch (e) {
        console.error(e);
    }
}

function DrawPic(imageId) {

    var canvas = document.getElementById('imageView');
    canvas.height = pageHeights[imageId];

    var canvas2 = document.getElementById('imageTemp');
    canvas2.height = pageHeights[imageId];

    var context = canvas.getContext('2d');

    context.clearRect(0, 0, canvas.width, canvas.height);


    var rand = Math.random();

    image1 = `/PdfPage/GetPageImage/?folder=${documentId}&filename=${imageId}`;
    //image1 = `/AsposePdfEditor/Controllers/Page/preview/?documentId=${documentId}/&imageId=${imageId}`;

    var img = new Image();
    img.src = image1;
    $('#imageView').css('background-size', 'contain');
    $('#imageView').css('background-repeat', 'no-repeat');
    $('#imageView').css('background-image', 'url(' + img.src + ')');





    setTimeout(function () {
        // Your code after the delay
    }, 60000);
    return true;
}

function First() {
    let dataP = dataLoad.split('%#');
    Npages = dataP[0].split(',');
    aRatio = dataP[1].split(',');
    heights = dataP[2].split(',');
    if (dataP.length > 3)
        fieldData = dataP[3];
    else
        fieldData = '';

    addFields(fieldData);
    for (var i = 0; i < heights.length; i++) {
        pageHeights[Npages[i]] = heights[i];
    }

    if ($('#hdnOpp').val() === 'uploading' || $('#hdnOpp').val() === 'dbox' || $('#hdnOpp').val() === 'Empty') {
        currentPage = 1;
        onStartup();
    }

    DrawPic(Npages[currentPage - 1]);
    //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
    DrawShapes();

    ManageFields();
    if (Npages.length == 1) {
        //NextPage.SetEnabled(false);
        var item = Pdfmenu.GetItemByName("NextPage");
        item.SetEnabled(false);
        $(".NextPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_right_arrow_disabled");
    }
     
}

function Next() {
    if (currentPage < Npages.length) {
        currentPage = currentPage + 1;
        DrawScreen();
        DrawPic(Npages[currentPage - 1]);
        var promise = jQuery.when().promise();
        promise = promise.then(wait);
        promise.done(function () {
            DrawShapes();
            ManageFields();
        });
    }

    //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
    if (currentPage > 1) {
        var item = Pdfmenu.GetItemByName("PreviousPage");
        item.SetEnabled(true);
        $(".PreviousPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_left_arrow_normal");
    }
    if (currentPage == Npages.length) {
        //NextPage.SetEnabled(false);
        var item = Pdfmenu.GetItemByName("NextPage");
        item.SetEnabled(false);
        $(".NextPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_right_arrow_disabled");

    }
    if (currentPage == 1) {

        var item = Pdfmenu.GetItemByName("PreviousPage");
        item.SetEnabled(false);
        $(".PreviousPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_left_arrow_disabled");
    }
}

function Previous() {
    if (currentPage > 1) {
        currentPage = currentPage - 1;
        DrawScreen();
        DrawPic(Npages[currentPage - 1]);
        var promise = jQuery.when().promise();
        promise = promise.then(wait);
        promise.done(function () {
            DrawShapes();
            ManageFields();
        });
    }

    //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
    if (Npages.length > 1) {
        var itemNextPage = Pdfmenu.GetItemByName("NextPage");
        itemNextPage.SetEnabled(true);
        $(".NextPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_right_arrow_normal");
    }
    if (currentPage == 1) {
        var item = Pdfmenu.GetItemByName("PreviousPage");
        item.SetEnabled(false);
        $(".PreviousPageAction .dxm-image").removeClass().addClass("dx-vam dxm-image ws_left_arrow_disabled");
    }
}

function AddPage() {
    //$('#loadingModal').modal('show');
    $.ajax({
        type: 'POST',
        url: `/Page/AddPage/${documentId}`,
        data: '{ "lastpage" : "' + Npages[Npages.length - 1] + '" }',
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data) {
            datasplit = data.pages.split("#");
            Npages.push(datasplit[0]);
            aRatio.push(datasplit[2]);
            heights.push(datasplit[1]);
            for (let i = 0; i < heights.length; i++) {
                pageHeights[Npages[i]] = heights[i];
            }
            //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
        },
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function DeletePage() {
    //$('#loadingModal').modal('show');

    function isFromPage(page) {
        return page == currentPage;
    }
    shapes = shapes.filter(isFromPage);

    var deleteData = JSON.stringify({ 'pageNumber': currentPage, 'documentId': documentId });
    return $.ajax({
        type: 'DELETE',
        url: `/Page/DeletePage`,
        data: deleteData,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            updateIndexesDelete();
        },
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function updateIndexesDelete() {
    DeleteShapes();

    Npages.splice(currentPage - 1, 1);

    if (currentPage > Npages.length) {
        currentPage = Npages.length;
    }

    DrawPic(Npages[currentPage - 1]);
    //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
}

function DeleteShapes() {
    for (let i = 0; i < shapes.length; i++) {
        if (shapes[i].Page === Npages[currentPage - 1]) {

            shapes.splice(i, 1);
        }
    }
}

function DelShape() {
    $('#divDel').css('visibility', 'hidden');
    DrawScreen();

    shapes.splice(selectedShape, 1);
    DrawShapes();

    selectedShape = -1;
    var item = Pdfmenu.GetItemByName("Drag");
    if (shapes.length > 0) {
        item.SetEnabled(true);
        $(".btnDrag .dxm-image").removeClass().addClass("dx-vam dxm-image ws_icon_delete_access_normal");
    }
    else {
        item.SetEnabled(false);
        $(".btnDrag .dxm-image").removeClass().addClass("dx-vam dxm-image ws_icon_delete_access_disabled");
    }
}

function wait(ms) {
    var deferred = jQuery.Deferred();
    var intervalId = setInterval(function () {
        clearInterval(intervalId);
        deferred.resolve();
    }, 100);
    return deferred.promise();
}

function ReplaceText() {
    let txtFind = $('#txtFind').val();
    let txtReplace = $('#txtReplace').val();
    let movedata = JSON.stringify({ 'txtFind': txtFind, 'txtReplace': txtReplace, 'pageList': Npages, 'documentId': documentId });

    //$('#loadingModal').modal('show');
    // Sending the image data to Server
    $.ajax({
        type: 'PUT',
        url: `/Text/ReplaceText`,
        data: movedata,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            AfterSearch();
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }

    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function Move() {
    let moveTo = $('#txtMove').val();
    if ($('#hdnMove').val() === 'moving') {
        movedata = JSON.stringify({ 'moveFrom': currentPage.toString(), 'moveTo': moveTo, 'pageList': Npages, 'documentId': documentId });
        //$('#loadingModal').modal('show');
        $.ajax({
            type: 'PUT',
            url: `/Page/MovePages`,
            data: movedata,
            contentType: 'application/json; charset=utf-8',
            dataType: 'json',
            success: function (data, textStatus, jqXHR) {
                Npages = data.pageList;
                MoveUpdate();
            },
            error: function (xhr, textStatus, error) {
                alertModal('Error: ', xhr, textStatus, error);
            }
        })
            .done(function () { $('#loadingModal').modal('hide'); });
    }
    else {
        //$('#loadingModal').modal('show');
        movedata = JSON.stringify({ 'searchText': moveTo, 'pageList': Npages, 'documentId': documentId });
        // Sending the image data to Server
        $.ajax({
            type: 'POST',
            url: `/Text/SearchData`,
            data: movedata,
            contentType: 'application/json; charset=utf-8',
            dataType: 'json',
            success: function (data, textStatus, jqXHR) {
                AfterSearch();
            },
            //call on ajax call failure
            error: function (xhr, textStatus, error) {
                alertModal('Error: ', xhr, textStatus, error);
            }
        })
            .done(function () { $('#loadingModal').modal('hide'); });
    }
}

function moveClick(event) {
    event.preventDefault();
    GeneralSetup('Move');
}

function appendClick(event) {
    event.preventDefault();
    GeneralSetup('Append');
}

function clearSearchClicked() {
    let cleardata = JSON.stringify({ 'searchText': '', 'pageList': Npages, 'documentId': documentId });
    $.ajax({
        type: 'DELETE',
        url: `/Text/SearchClear`,
        data: cleardata,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            AfterSearch();
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function AfterSearch() {
    DrawScreen();
    DrawPic(Npages[currentPage - 1]);
    var promise = jQuery.when().promise();
    promise = promise.then(wait);
    promise.done(function () {
        DrawShapes();
    });
}

function btnExportClick() {
    // Sending the image data to Server
    $.ajax({
        type: 'POST',
        url: `export-pdf`,
        data: '{}',
        contentType: 'application/json; charset=utf-8',
        dataType: 'json'
    });

}

function MoveUpdate() {
    for (var i = 0; i < Npages.length; i++) {
        for (var j = 0; j < shapes.length; j++) {

            if (Npages[i] === shapes[j].f) {
                shapes[j].page = i + 1;
            }
        }

    }
    DrawScreen();

    DrawPic(Npages[currentPage - 1]);

    DrawShapes();

    //document.getElementById('lblPages').innerHTML = 'Page ' + currentPage + '  Of ' + Npages.length;
}

function fnEditWorkSapceMenuItemClicked(s, e) {
    $name = e.item.name;
    if ($name == "SaveChanges") {
        GeneralSetup('Save');
        SavePdf(false);
        
    }
    if ($name == "PreviousPage") {
        GeneralSetup('Previous'); Previous();
    }
    if ($name == "NextPage") {
        GeneralSetup('Next'); Next();
    }
    if ($name == "AddText") {
        isDocumentEdited = true;
        GeneralSetup('Text');
        tool = new tools['texting']();
    }
    if ($name == "Drag") {
        GeneralSetup('Drag');
        tool = new tools['dragging']();
    }
}

function SavePdf(closeDocument) {
    //$('#loadingModal').modal('show');
    LoadingPanel.SetText("Saving Pdf...");
    LoadingPanel.Show();
    let filename = 'image'.concat(currentPage).concat('.png');

    shapes2 = [];

    for (var i = 0; i < shapes.length; i++) {
        tempShape = {
            x: shapes[i].x.toString(),
            y: shapes[i].y.toString(),
            textWidth: shapes[i].textWidth.toString(),
            fontHeight: shapes[i].fontHeight.toString(),
            page: shapes[i].page.toString(),
            f: shapes[i].f.toString(),
            text: shapes[i].text.toString(),
            fontText: shapes[i].fontText.toString(),
            fontSize: shapes[i].fontSize.toString(),
            fontColor: shapes[i].fontColor.toString(),
            fontWeight: shapes[i].fontWeight.toString(),
            fontStyle: shapes[i].fontStyle.toString(),
            ratio: shapes[i].ratio.toString(),
            imfile: '',
            imName: shapes[i].imName,
            Itype: shapes[i].Itype.toString(),
            fieldType: shapes[i].fieldType.toString(),
            FieldName: shapes[i].fieldName.toString(),
            FieldLLX: shapes[i].fieldLLX.toString(),
            FieldLLY: shapes[i].fieldLLY.toString()
        };
        shapes2.push(tempShape);
    }
    var streditInfo = $('#editInfo').val();
    var strFolderPath = $('#strFolderPath').val();
    var strpdf_aspose_file = $('#strPDFASPOSEFILE').val();


    wholedata = JSON.stringify({ 'shapes': shapes2, 'filename': filename, 'aspectRatio': ratio.toString(), 'documentId': documentId, editInfo: streditInfo, pdf_aspose_file: strpdf_aspose_file });



    $.post("/PdfShape/AddShapes", { "shapes": shapes2, "editInfo": streditInfo, "pdf_aspose_file": strpdf_aspose_file,'imageDirectory': documentId })
        .done(function (data) {
            if (data.success == true) {
                bHasUnsavedChanges = false;
                shapes = [];
                if (closeDocument == false) {
                    ddFont.SetSelectedIndex(0);                    
                    ddSize.SetSelectedIndex(3);
                    LoadingPanel.Hide();
                    fileSelectedOnload();
                    fnShowToaster("Pdf saved");
                }
                else {
                    fncloseDocument();
                }
            }
            else {
                console.log("AddShapes data.result false ");
                if (data.message != "") {
                    alert('Error SavePDF AddShapes: ' + data.message);
                }
            }
        })
        .fail(function () {
            alert("error");
        });
    var item = Pdfmenu.GetItemByName("Drag");
    item.SetEnabled(false);
    $(".btnDrag .dxm-image").removeClass().addClass("dx-vam dxm-image ws_icon_delete_access_disabled");
    var item = Pdfmenu.GetItemByName("SaveChanges");
    item.SetEnabled(false);
    $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_disabled");
    //$.ajax({
    //    type: 'POST',
    //    url: `/PdfShape/AddShapes`,
    //    data: wholedata,
    //    contentType: 'application/json; charset=utf-8',
    //    dataType: 'json',
    //    success: function (data) {
    //        if (data.success == true) {
                
    //            bHasUnsavedChanges = false;
    //            //  LoadingPanel.SetText("Saved successfully");
    //            LoadingPanel.Hide();
    //            //try {
    //            //    var p1 = strFolderPath;
    //            //    var p = p1.replace(/\\/g, "/");
    //            //    if (p.charAt(0) == '/') {
    //            //        p = p.substr(1);
    //            //    }
    //            //    let tp = fnReplaceBackslash(p);
    //            //    //we shall send signalr notification
    //            //    //fnSendUpdateForFileInFs(p, b64EncodeUnicode(tp), "");
    //            //} catch (e) { }
    //            fnShowToaster("Pdf saved");
    //        }
    //        else {
    //            alert('Error SavePDF AddShapes: ' + data.message);
    //        }

    //    },
    //    error: function (xhr, textStatus, error) {
    //        alertModal('Error SavePDF: ', xhr, textStatus, error);
    //    }
    //}).done(function () {
    //        LoadingPanel.Hide();
    //        fnShowToaster("Pdf saved");
    //    });
}

function DrawScreen() {
    let canvas = document.getElementById('imageView');
    let contextd = canvas.getContext('2d');

    contextd.clearRect(0, 0, canvas.width, canvas.height);
    document.getElementById('imageTemp').getContext('2d').clearRect(0, 0, canvas.width, canvas.height);
}

function DrawShapes() {
    let canvas = document.getElementById('imageView');
    let context = canvas.getContext('2d');

    for (let i = 0; i < shapes.length; i++) {
        if (shapes[i].f === Npages[currentPage - 1]) {

            if (shapes[i].Itype === 'highlight') {
                context.fillStyle = 'rgba(255, 230, 81, 0.5)';
                context.fillRect(shapes[i].x, shapes[i].y, shapes[i].textWidth, shapes[i].fontHeight);
            }
            if (shapes[i].Itype === 'image') {

                var image1 = 'Images/'.concat(shapes[i].imfile);

                imageObj = shapes[i].imfile;

                context.drawImage(imageObj, shapes[i].x, shapes[i].y, shapes[i].textWidth, shapes[i].fontHeight);

            }
            if (shapes[i].Itype === 'text') {


                context.save();
                context.translate(shapes[i].x, shapes[i].y + parseInt(shapes[i].fontSize));

                //context.rotate(shapes[i].fieldType);

                //set the font styles
                var font = shapes[i].fontText;
                var fontsize = shapes[i].fontSize;
                var fontweight = shapes[i].fontWeight;
                var fontstyle = shapes[i].fontStyle;
                context.fillStyle = shapes[i].fontColor;

                //draw the text
                context.font = fontstyle + ' ' + fontweight + ' ' + fontsize + 'px ' + font;

                context.fillText(shapes[i].text,0, 0);

                context.restore();
            }

        }
    }

}

$(document).on('click', '.open-uploadModal', function () {
    let operationId = $(this).data('id');
    console.log(operationId);
    $('#hdnOpp').val(operationId);
});

$(document).on('click', '.open-moveModal', function () {

    let myId = $(this).data('id');

    $('#hdnMove').val(myId);

    if (myId === 'searching') {

        $('#btnMove').html('Search');
        $('#H1').html('Search Text');
        $('#lblpagemove').html('Enter Text to Search');
    }
    else {

        $('#btnMove').html('Move');
        $('#H1').html('Move Page After');
        $('#lblpagemove').html('Enter Page Number');
    }
});
$(document).ready(function () {

    // Use event delegation to bind keyup event to dynamically added textareas
    $(document).on("keyup", "textarea", function () {
        // Your keyup event handler code here
        bHasUnsavedChanges = true;
        var item = Pdfmenu.GetItemByName("SaveChanges");
        item.SetEnabled(true);
        $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_normal");
    });
    $(window).bind("beforeunload", function (event) {
       
        event.preventDefault();
        event.returnValue = false;
      
        var streditInfo = $('#editInfo').val();
        var wholeData = JSON.stringify({ 'id': streditInfo, 'removeSessionData': "false" });
        var strFolderPath = $('#strFolderPath').val();     
        var strpdf_aspose_file = $('#strPDFASPOSEFILE').val();
        if (documentClosed == false) {
            fncloseEditorWindow(streditInfo, strFolderPath, bHasUnsavedChanges, documentId, strpdf_aspose_file);
        }   
        if (bHasUnsavedChanges == true) {
            LoadingPanel.Hide();
            ConfirmPopup.Show();            
        } else {
            return;
        }
    });

    //2024-04-05 SN: #10012
    function updateLastEditTime() {
        // Make an Ajax call to your controller endpoint
        var streditInfo = $('#editInfo').val();
        var strpdf_aspose_file = $('#strPDFASPOSEFILE').val();
        var wholeData = JSON.stringify({ 'fileid': streditInfo, 'strpdf_aspose_file': strpdf_aspose_file });
        var url = '/Home/UpdateLasEditTime';
        var xhr = new XMLHttpRequest();
        xhr.open('POST', url, true);
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
                // Handle the response here if needed
                console.log(xhr.responseText);
            }
        };
        xhr.send(wholeData);
    }

    // Call the controller function every 5 seconds
    setInterval(updateLastEditTime, 5000); // 5000 milliseconds = 5 seconds
    //2024-04-05 SN: #10012
});
function fileSelected() {
    $('#uploadModal').modal('hide');
    let fd = new FormData();
    fd.append('fileToUpload', document.getElementById('fileToUpload').files[0]);
    fd.append('Opp', $('#hdnOpp').val());
    if (typeof documentId !== 'undefined' && documentId != 'undefined')
        fd.append('documentId', documentId);

    if ($('#hdnOpp').val() === 'appending') {
        fd.append('pages', Npages);
        fd.append('ratios', aRatio);
        fd.append('heights', heights);

    }

    var xhr = new XMLHttpRequest();
    switch ($('#hdnOpp').val()) {
        case 'uploading':
            xhr.open('POST', `/Home/PdfEditorUpload`);

            break;
        case 'appending':
            xhr.open('PUT', `/PdfDocument/Append`);
            break;
        case 'addAttachment':
            xhr.open('POST', `/PdfAttachment/Upload`);
            break;
        default:
            xhr.open('POST', `/Shape/UploadImage`);
            break;
    }

    xhr.upload.onprogress = function (event) {
        if (event.lengthComputable) {
            $('.progress-bar').width('60%');
        }
    };

    xhr.onreadystatechange = function () {

        if (xhr.readyState === 4) {
            if (xhr.status >= 300) {
                alertModal(xhr.statusText);
                return;
            }

            data = JSON.parse(xhr.responseText);
            dataLoad = data.Pages;
            documentId = data.DocumentId;
            if ($('#hdnOpp').val() === 'appending') {
                First();
            }
            else
                if ($('#hdnOpp').val() === 'uploading') {
                    for (i = 0; i < shapes.length; i++) {
                        var shapeDiv = document.getElementById('div_' + shapes[i].imName + '');
                        var shape = document.getElementById(shapes[i].imName);
                        if (shape !== null) {
                            $('#' + shapes[i].imName + '').remove();
                        }
                        if (shapeDiv !== null) {
                            shapeDiv.parentNode.removeChild(shapeDiv);
                        }
                    }

                    shapes2.length = 0;
                    shapes.length = 0;
                    Attachments.length = 0;
                    GetAttachments();
                    First();
                }
                else if ($('#hdnOpp').val() === 'addAttachment') {
                    GetAttachments();
                }
                else {
                    InsertImages(dataLoad, 50, 50);
                }

            $('.progress-bar').width('100%');


            $('#fileToUpload').wrap('<form>').parent('form').trigger('reset');
            $('#fileToUpload').unwrap();
            $('#fileToUpload').prop('files')[0] = null;
            $('#fileToUpload').replaceWith($('#fileToUpload'));
            $('.progress-bar').width('0%');
        }
    };

    xhr.send(fd);

    
}

function fileSelectedOnload() {   
    LoadingPanel.SetText("Document loading...");
    LoadingPanel.Show();
    $('#hdnOpp').val("uploading");
    var xhr = new XMLHttpRequest();
    xhr.open('POST', `/Home/PdfEditorUpload`);

    xhr.upload.onprogress = function (event) {
        if (event.lengthComputable) {
            $('.progress-bar').width('60%');
        }
    };

    xhr.onreadystatechange = function () {

        if (xhr.readyState === 4) {
            if (xhr.status >= 300) {
                alertModal(xhr.statusText);
                return;
            }

            data = JSON.parse(xhr.responseText);
            dataLoad = data.Pages;
            if (dataLoad != null) {
                documentId = data.DocumentId;
                First();

            }
            else {
                documentClosed = true;
                window.close();
            }
            LoadingPanel.Hide();
        }
    };

    xhr.send();
}

function anchorHitTest(shape, x, y, context) {
    anchorVal = -1;
    if (x > shape.x && x < (shape.x + 10) && y < (shape.y + 10) && y > shape.y && shape.Itype === 'image') {
        anchorVal = 0;
        return anchorVal;
    }
    else if (x > (shape.x + shape.textWidth - 10) && x < (shape.x + shape.textWidth) && y < (shape.y + 10) && y > shape.y && shape.Itype === 'image') {

        anchorVal = 1;

        return anchorVal;
    }
    else if (x > shape.x && x < (shape.x + 10) && y > (shape.y + shape.fontHeight - 10) && y < (shape.y + shape.fontHeight) && shape.Itype === 'image') {

        anchorVal = 2;
        return anchorVal;
    }
    else if (x > (shape.x + shape.textWidth - 10) && x < (shape.x + shape.textWidth) && y > (shape.y + shape.fontHeight - 10) && y < (shape.y + shape.fontHeight) && shape.Itype === 'image') {
        anchorVal = 3;
        return anchorVal;
    }

    else if (x > (shape.x + shape.textWidth - 5) && x < (shape.x + shape.textWidth + 5) && y < (shape.y + (shape.fontHeight / 2) + 10) && y > (shape.y + (shape.fontHeight / 2) - 10) && shape.Itype === 'text') {
        anchorVal = 5;
        return anchorVal;
    }
    else if (shape.Itype === 'text') {

        context.save();

        context.translate(shape.x, shape.y + parseInt(shape.fontSize));
        //context.rotate(shape.fieldType);

        context.beginPath();
        context.rect(shape.textWidth - 5, (shape.fontHeight / -2) - 5, 10, 10);

        var result = context.isPointInPath(x, y);

        context.restore();
        if (result) {

            anchorVal = 5;
        }
        return anchorVal;

    }
    else { return -1; }

}

function hitTest(shape, mx, my, context) {

    if (shape.Itype === 'text') {

        context.save();

        context.translate(shape.x, shape.y + parseInt(shape.fontSize));
        context.rotate(shape.fieldType);

        context.beginPath();
        context.rect(0, -shape.fontHeight, shape.textWidth + 5, shape.fontHeight);

        var result = context.isPointInPath(mx, my);

        context.restore();

        return result;
    }

    if (mx > shape.x && mx < shape.x + shape.textWidth) {
        if (my > shape.y && my < shape.y + shape.fontHeight) {
            return true;
        }
        else {

            return false;
        }
    }
    else {

        return false;
    }

}

function InsertImages(data, imgLeft, imgTop) {
    let canvas = document.getElementById('imageView');
    let context = canvas.getContext('2d');
    let bRect = canvas.getBoundingClientRect();
    //image1 = `/PdfPage/GetPageImage?folder=${documentId}/&filename=${data}`;

    image1 = `/PdfPage/GetPageImage/?folder=${documentId}/&filename=${imageId}`;
    var img = new Image();
    img.src = image1;


    let imgWidth = 0;
    let imgHeight = 0;

    imageObj = new Image();

    imageObj.onload = function () {
        context.drawImage(imageObj, imgLeft, imgTop);
        imgWidth = this.width;
        imgHeight = this.height;

        tempShape =
        {
            x: imgLeft,
            y: imgTop,
            textWidth: imgWidth,
            fontHeight: imgHeight,
            page: currentPage,
            f: Npages[currentPage - 1],
            text: '',
            fontText: '',
            fontSize: '',
            fontColor: '',
            fontWeight: '',
            fontStyle: '',
            ratio: aRatio[currentPage - 1],
            imfile: imageObj,
            imName: data,
            Itype: 'image',
            fieldType: '',
            fieldName: '',
            fieldLLX: '',
            fieldLLY: ''
        };
        shapes.push(tempShape);

    };
    imageObj.src = img.src;
    imageObj.style.zIndex = 500 + shapes.length;
}

function ExportByType(fileType, documentId) {

    const a = document.createElement('a')
    a.href = `/PdfDocument/Download?fileType=${fileType}&folder=${documentId}`
    a.download = `/PdfDocument/Download?fileType=${fileType}&folder=${documentId}`.split('/').pop() + '.' + fileType;
    document.body.appendChild(a)
    a.click()
    document.body.removeChild(a);
}

function ExportFile(fileType) {
    //$('#loadingModal').modal('show');
    $.ajax({
        type: 'POST',
        url: `/PdfDocument/ExportFile?fileType=${fileType}&folder=${documentId}`,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            ExportByType(fileType, documentId);
            $('#loadingModal').hide();
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })

}

function ddFontChange() {
    let dFont = ddFont.GetSelectedItem().value;// document.getElementById('ddFont');
    fontText = dFont;
    $('#textareaTest').css('font-family', fontText);
}

function ddSizeChange() {
    let dSize = ddSize.GetSelectedItem().value;// document.getElementById('ddSize');
    fontSize = dSize;
    $('#textareaTest').css('font-size', fontSize + 'px');
}

function makeBold() {
    if ($('#btnBold').hasClass('active')) {

        $('#textareaTest').css('font-weight', 'normal');
        fontWeight = 'normal';
    }
    else {
        $('#textareaTest').css('font-weight', 'bold');
        fontWeight = 'bold';
    }
}

function makeItalic() {
    if ($('#btnItalic').hasClass('active')) {

        $('#textareaTest').css('font-style', 'italic');
        fontStyle = '';
    }
    else {
        $('#textareaTest').css('font-style', 'italic');
        fontStyle = 'italic';
    }
}

function selectColor(color_this) {
    $('#textareaTest').css('color', color_this.name);
    $('#btnColor').css('background-color', color_this.name);
    fontColor = color_this.name;
    $('#myColors').modal('hide');
}

function closeTextEditor() {
    $('#textAreaPopUp').css('visibility', 'hidden');
}

function GeneralSetup(process) {
    for (i = 0; i < shapes.length; i++) {
        if (shapes[i].f === Npages[currentPage - 1]) {
            if (shapes[i].Itype === 'field') {
                let getField = document.getElementById(shapes[i].imName);
                if (getField !== null) {
                    if (shapes[i].fieldType === 'Text') {
                        shapes[i].text = getField.value;
                    }
                    else if (shapes[i].fieldType === 'ComboBox') {
                        let optValues = getField.value;
                        for (x = 0; x < getField.options.length; x++) {
                            optValues = optValues + '^^^' + getField.options[x].value;
                        }
                        shapes[i].text = optValues;
                    }
                    else if (shapes[i].fieldType === 'CheckBox' || shapes[i].fieldType === 'Radio') {
                        shapes[i].text = getField.checked;
                    }
                }
            }
        }
    }

    $('#textAreaPopUp').css('visibility', 'hidden');
    $('#divDel').css('visibility', 'hidden');
    $('#divSignature').css('visibility', 'hidden');

    if (process != "Text" && process != "Drag" ) {
       // DrawScreen();
       // DrawShapes();
    }

    currentTools = process;
}

function moveModeClose() {
    $('#hdnMove').val('');
}

function addFields(fieldData) {
    if (fieldData !== '') {
        var dataValues = fieldData.split('$#$');

        for (i = 0; i < dataValues.length; i++) {
            tempShape =
            {
                x: dataValues[i + 0],
                y: dataValues[i + 1],
                textWidth: dataValues[i + 2],
                fontHeight: dataValues[i + 3],
                page: dataValues[i + 4],
                f: dataValues[i + 5],
                text: dataValues[i + 6],
                fontText: dataValues[i + 7],
                fontSize: dataValues[i + 8],
                fontColor: dataValues[i + 9],
                fontWeight: dataValues[i + 10],
                fontStyle: dataValues[i + 11],
                ratio: dataValues[i + 12],
                imfile: dataValues[i + 13],
                imName: dataValues[i + 14],
                Itype: 'field',
                fieldType: dataValues[i + 15],
                fieldName: dataValues[i + 16],
                fieldLLX: dataValues[i + 17],
                fieldLLY: dataValues[i + 18]
            };
            shapes.push(tempShape);
            i = i + 18;
        }
    }
}

function ManageFields() {
    for (let i = 0; i < shapes.length; i++) {
        var shapeDiv = document.getElementById('div_' + shapes[i].imName + '');
        var shape = document.getElementById(shapes[i].imName);

        if (shape !== null) {
            $('#' + shapes[i].imName + '').remove();
        }

        if (shapeDiv !== null) {
            shapeDiv.parentNode.removeChild(shapeDiv);
        }
    }

    var canvas = document.getElementById('imageView');

    for (let i = 0; i < shapes.length; i++) {
        if (shapes[i].f === Npages[currentPage - 1]) {

            if (shapes[i].Itype === 'field') {

                var rect = canvas.getBoundingClientRect();

                var fld = document.getElementById('div_' + shapes[i].imName + '');

                if (fld === null) {
                    var wrapper = document.createElement('div');

                    wrapper.style.left = (rect.left + parseInt(shapes[i].x) + 2) + 'px';
                    wrapper.style.top = (rect.top + parseInt(shapes[i].y) + 2) + 'px';
                    wrapper.style.width = parseInt(shapes[i].textWidth - 2) + 'px';
                    //wrapper.style.height = parseInt(shapes[i].fontHeight - 2) + 'px';
                    wrapper.id = 'div_' + shapes[i].imName;
                    wrapper.style.zIndex = 50 + i;
                    wrapper.style.position = 'absolute';

                    if (shapes[i].fieldType === 'Text') {
                        wrapper.className = 'info';
                        wrapper.setAttribute('display', 'block');
                        var textarea = document.createElement('textarea');
                        textarea.className = 'tbox';
                        textarea.value = shapes[i].text;
                        textarea.style.width = (parseInt(shapes[i].textWidth) - 2) + 'px';
                        textarea.style.height = (parseInt(shapes[i].fontHeight) - 2) + 'px';
                        textarea.style.left = '0px';
                        textarea.style.top = '0px';
                        textarea.style.zIndex = 150 + i;

                        if (shapes[i].fontStyle === 'True') {
                            textarea.style.backgroundColor = '#FFE4E1';
                        }
                        textarea.id = shapes[i].imName;
                        textarea.name = shapes[i].fieldName;
                        wrapper.appendChild(textarea);
                    }
                    else if (shapes[i].fieldType === 'CheckBox') {

                        wrapper.className = 'info';
                        wrapper.style.left = (rect.left + (parseInt(shapes[i].x))) + 'px';
                        wrapper.style.top = (rect.top + (parseInt(shapes[i].y))) + 'px';

                        if (shapes[i].fontStyle === 'True') {
                            wrapper.style.backgroundColor = '#FFE4E1';
                        }
                        var checkbox = document.createElement('input');
                        checkbox.type = 'checkbox';
                        checkbox.name = shapes[i].imfile;

                        if (shapes[i].text === 'true' || shapes[i].text === true) {
                            checkbox.checked = true;

                        }
                        else {

                            checkbox.checked = false;
                        }
                        checkbox.style.zIndex = 150 + i;
                        checkbox.id = shapes[i].imName;
                        checkbox.style.width = (parseInt(shapes[i].textWidth)) + 'px';
                        checkbox.style.height = (parseInt(shapes[i].fontHeight) - 5) + 'px';
                        wrapper.appendChild(checkbox);
                    }
                    else if (shapes[i].fieldType === 'Radio') {
                        wrapper.className = 'Mine';
                        wrapper.style.left = (rect.left + parseInt(shapes[i].x)) + 'px';
                        wrapper.style.top = (rect.top - 1 + parseInt(shapes[i].y)) + 'px';

                        if (shapes[i].fontStyle === 'True') {
                            wrapper.style.backgroundColor = '#FFE4E1';
                        }
                        var radio = document.createElement('input');
                        radio.type = 'radio';
                        radio.id = shapes[i].imName;
                        radio.name = shapes[i].imfile;
                        if (shapes[i].text === 'true' || shapes[i].text === true) {
                            radio.checked = true;

                        }
                        else {

                            radio.checked = false;
                        }
                        radio.style.zIndex = 150 + i;
                        radio.id = shapes[i].imName;
                        radio.style.width = (parseInt(shapes[i].textWidth)) + 'px';
                        radio.style.height = (parseInt(shapes[i].fontHeight)) + 'px';
                        wrapper.appendChild(radio);
                    }
                    else if (shapes[i].fieldType === 'ComboBox') {

                        wrapper.className = 'tbox';
                        var combo = document.createElement('select');
                        combo.id = shapes[i].imName;
                        combo.style.zIndex = 150 + i;
                        var values = shapes[i].text.split('^^^');
                        combo.className = 'tbox';
                        combo.style.width = (shapes[i].textWidth - 2) + 'px';
                        if (shapes[i].fontStyle === 'True') {
                            combo.style.backgroundColor = '#FFE4E1';
                        }
                        for (j = 1; j < values.length; j++) {

                            var option1 = document.createElement('option');
                            option1.value = values[j];
                            option1.innerHTML = values[j];
                            combo.appendChild(option1);

                        }
                        if (values[0] !== '') {

                            var opts = combo.options.length;
                            for (var k = 0; k < opts; k++) {
                                if (combo.options[k].value === values[0]) {
                                    combo.options[k].selected = true;
                                    break;
                                }
                            }
                        }
                        wrapper.appendChild(combo);
                    }

                    document.body.appendChild(wrapper);
                }
            }
        }
    }
}
function GetAttachments() {
    // Sending the image data to Server
    $.ajax({
        type: 'GET',
        url: `/PdfAttachment/GetFileAttachments/`,
        data: { 'folder': documentId },
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            Attachments = data.files.split(',');
            var table = document.getElementById('tblAttach');
            while (table.rows.length > 1) {
                table.deleteRow(1);
            }
            var count = 1;
            for (i = 0; i < Attachments.length - 1; i++) {

                var row = table.insertRow(table.rows.length);
                var cell1 = row.insertCell(0);
                var cell2 = row.insertCell(1);
                var cell3 = row.insertCell(2);
                var cell4 = row.insertCell(3);


                // Add some text to the new cells:
                cell1.innerHTML = Attachments[i];
                cell2.innerHTML = Attachments[i + 1];

                let pos = Attachments[i].lastIndexOf('.');
                let attachFileName = Attachments[i].substr(0, pos) + '_' + Attachments[i].substr(pos + 1);
                cell3.innerHTML = `<a href="/GetFileAttachments/${documentId}/${attachFileName}" download class="btn btn-default" role="button">Download</a>`;

                name = Attachments[i];

                button = document.createElement('input'); // create a button
                button.setAttribute('type', 'button'); // set attributes ...
                button.setAttribute('name', count);
                button.setAttribute('value', 'Remove');
                button.setAttribute('class', 'btn btn-danger');
                button.onclick = (function () {
                    let currentName = name;
                    let index = count;
                    return function () {
                        RemoveAttachment(currentName, index);
                    };

                })();

                cell4.appendChild(button);
                count = count + 1;
                i = i + 1;
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function RemoveAttachment(name, rowId) {
    let removeData = JSON.stringify({ 'attachmentFileName': name, 'documentId': documentId });
    // Sending the image data to Server
    $.ajax({
        type: 'DELETE',
        url: `/PdfAttachment/RemoveFileAttachment`,
        data: removeData,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function () {
            document.getElementById('tblAttach').deleteRow(rowId);
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function GetFileExists() {
    var folder = typeof window.folderName !== 'undefined'
        && window.folderName != 'undefined' ?
        window.folderName : "";

    var file = typeof window.fileName !== 'undefined'
        && window.fileName != 'undefined' ?
        window.fileName : "";

    $.ajax({
        type: 'GET',
        url: `/PdfDocument/GetInfo?folder=${folder}&fileName=${file}`,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data, textStatus, jqXHR) {
            dataLoad = data.pages;
            documentId = data.documentId;
            console.log(data);
            for (let i = 0; i < shapes.length; i++) {
                var shapeDiv = document.getElementById('div_' + shapes[i].imName + '');
                var shape = document.getElementById(shapes[i].imName);
                if (shape !== null) {
                    $('#' + shapes[i].imName + '').remove();
                }

                if (shapeDiv !== null) {
                    shapeDiv.parentNode.removeChild(shapeDiv);
                }
            }

            $('#hdnOpp').val('Empty');
            shapes2.length = 0;
            shapes.length = 0;
            Attachments.length = 0;
            $('#loadingModal').modal('hide');
            First();
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function newFileClick(action) {
    $.ajax({
        type: 'POST',
        url: `/PdfDocument/Create`,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        success: function (data) {
            dataLoad = data.pages;
            documentId = data.documentId;
            for (i = 0; i < shapes.length; i++) {

                var shapeDiv = document.getElementById('div_' + shapes[i].imName + '');

                var shape = document.getElementById(shapes[i].imName);
                if (shape !== null) {
                    $('#' + shapes[i].imName + '').remove();
                }

                if (shapeDiv !== null) {
                    shapeDiv.parentNode.removeChild(shapeDiv);
                }
            }

            $('#hdnOpp').val('Empty');
            shapes2.length = 0;
            shapes.length = 0;
            Attachments.length = 0;
            First();
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alertModal('Error: ', xhr, textStatus, error);
        }
    })
        .done(function () { $('#loadingModal').modal('hide'); });
}

function clearSignature() {
    const signatureCanvas = document.querySelector('#signCanvas');
    signatureCanvas.width = signatureCanvas.width;
    const ctx = signatureCanvas.getContext('2d');
    ctx.lineWidth = 5;
    ctx.lineJoin = 'round';
    ctx.lineCap = 'round';
    ctx.strokeStyle = 'blue';
}

function saveSignature() {
    const signatureCanvas = document.querySelector('#signCanvas');
    const imageData = signatureCanvas.toDataURL('image/png');

    var form = new FormData();
    form.append("documentId", documentId);
    signatureCanvas.toBlob(function (blob) {
        form.append(imageData, blob, "signature.png");
        $.ajax({
            type: 'POST',
            url: `/Shape/UploadImage`,
            data: form,
            processData: false,
            contentType: false,
            success: function (data) {
                InsertImages(data.pages, signX, signY);
                $('#divSignature').css('visibility', 'hidden');
                currentTools = 'dragging';
                document.getElementById('btnDrag').click();
                var e = jQuery.Event('mousedown', { pageX: signX, pageY: signY });
                $('#imageView').trigger(e);
            }
        })
            .done(function () { $('#loadingModal').modal('hide'); });
    }, 'image/png');
}

function closeSignature() {
    $('#divSignature').css('visibility', 'hidden');
}

function onStartup() {
    document.getElementById('btnAddPage').disabled = false;
    document.getElementById('btnDeletePage').disabled = false;
    document.getElementById('btnMoving').disabled = false;
    document.getElementById('btnAppending').disabled = false;
    document.getElementById('btnSave').disabled = false;
    document.getElementById('btnExporting').disabled = false;
    document.getElementById('btnPrevious').disabled = false;
    document.getElementById('btnNext').disabled = false;
    document.getElementById('btnSearching').disabled = false;
    document.getElementById('btnImage').disabled = false;
    document.getElementById('btnRect').disabled = false;
    document.getElementById('btnRead').disabled = false;
    document.getElementById('btnDrag').disabled = false;
    document.getElementById('btnTexting').disabled = false;
    document.getElementById('btnAttachments').disabled = false;
    document.getElementById('btnSignature').disabled = false;
}

function drawRotationHandle(shape, context) {
    //context.save();

    //context.translate(shape.x, shape.y + parseInt(shape.fontSize));
    //context.rotate(shape.fieldType);

    //context.strokeStyle = 'brown';
    //context.setLineDash([6]);
    //context.strokeRect(0, -shape.fontHeight, shape.textWidth, shape.fontHeight);

    //context.fillStyle = '#7171C6';
    //context.fillRect(shape.textWidth - 5, (shape.fontHeight / -2) - 5, 10, 10);

    //context.restore();
}


$(document).on('change', '[type=checkbox]', function (event) {

    if (event.target.checked) {
        shapes[event.target.id].text = 'true';
    }
    else {
        shapes[event.target.id].text = 'false';
    }
    bHasUnsavedChanges = true;
    var item = Pdfmenu.GetItemByName("SaveChanges");
    item.SetEnabled(true);
    $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_normal");
});
$(document).on('change', '[type=radio]', function (event) {
    bHasUnsavedChanges = true;
    var item = Pdfmenu.GetItemByName("SaveChanges");
    item.SetEnabled(true);
    $(".btnSaveChanges .dxm-image").removeClass().addClass("dx-vam dxm-image ws_file_icon_normal");
});

function fnShowToaster($message) {
    ToasterMessage.innerHTML = $message;
    ToasterPopup.Show();
    setTimeout(function () {
        ToasterPopup.Hide();
    }, 3000);
}
function b64EncodeUnicode(str) {
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1) {
            return String.fromCharCode('0x' + p1);
        }));
}
function closeDocumentClicked() {
   
    bClosedUsingButton = true;
    if (bHasUnsavedChanges == true) {
        ConfirmPopup.Show();
    }
    else {
        ConfirmPopup.Hide();
        fncloseDocument();
        LoadingPanel.SetText("Closing...");
        LoadingPanel.Show();
    }
}

function fncloseDocument() {
    bHasUnsavedChanges = false;
    LoadingPanel.SetText("Closing...");
    LoadingPanel.Show();
    var streditInfo = $('#editInfo').val();
    var strFolderPath = $('#strFolderPath').val();
    var strpdf_aspose_file = $('#strPDFASPOSEFILE').val();
    console.log("1");
    var wholeData = JSON.stringify({ 'id': streditInfo, 'removeSessionData': "true", 'imageDirectory': documentId, 'strpdf_aspose_file': strpdf_aspose_file });
    console.log("2");
    $.ajax({
        type: 'POST',
        url: `/Home/fnClosePDfDocument`,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        data: wholeData,
        success: function (data) {
            if (data.result == true) {
                console.log("3");
                try {
                    //show document is in edit mode
                    var p1 = strFolderPath;
                    var p = p1.replace(/\\/g, "/");
                    if (p.charAt(0) == '/') {
                        p = p.substr(1);
                    }
                    console.log("4");
                    fnSendWsUpdate(p);
                    documentClosed = true;
                    //resetTimeout(true);
                    $(window).unbind("beforeunload");
                    //window.onbeforeunload = null;
                    window.close();

                } catch (e) {
                }
            }
            else {
                console.log("fnClosePDfDocument data.result false ");
                if (data.message != "") {
                    alert(data.message);
                }
            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            console.log("fnClosePDfDocument");
            //alertModal('fncloseDocument Error: ', xhr, textStatus, error);
        }
    });
    console.log("6");
    return null;
}

function fnCancelChanges() {
    ConfirmPopup.Hide();
    fncloseDocument();
}

function fnSaveChanges() {
    bHasUnsavedChanges = false;
    ConfirmPopup.Hide();
    GeneralSetup('Save');
    SavePdf(true);
    LoadingPanel.SetText("Closing...");
    LoadingPanel.Show();
    //fncloseDocument();
   
}

function wrapText(context, text, x, y, maxWidth, lineHeight) {
    let xValue=x;
    let yValue=y;
    let oldY = y;
    var words = text.split(" ");
    var line = "";
    for (var n = 0; n < words.length; n++) {
        var testLine = line + words[n] + " ";
        var metrics = context.measureText(testLine);
        var testWidth = metrics.width;
        if (testWidth > maxWidth) {

            // Check if the text goes beyond the canvas width, shift text left accordingly
            let textWidth = context.measureText(line).width;
            if (xValue + textWidth > context.canvas.width) {
                xValue = context.canvas.width - textWidth; // Adjust x position to keep text within canvas width
            }

            // Check if the text goes beyond the canvas height, shift text up accordingly
            if (yValue + lineHeight > context.canvas.height) {
                yValue = context.canvas.height - lineHeight; // Adjust y position to keep text within canvas height
            }
            
            newX = xValue;           
            context.fillText(line, xValue, yValue);

            line = words[n] + " ";
            yValue += lineHeight;
            newY = yValue;
        }
        else {
            line = testLine;
        }
    }
    // Check if the text goes beyond the canvas width, shift text left accordingly
    let textWidth = context.measureText(line).width;
    if (xValue + textWidth > context.canvas.width) {
        xValue = context.canvas.width - textWidth; // Adjust x position to keep text within canvas width
    }

    // Check if the text goes beyond the canvas height, shift text up accordingly
    if (yValue + lineHeight > context.canvas.height) {
        yValue = context.canvas.height - lineHeight; // Adjust y position to keep text within canvas height
    }
    
    context.fillText(line, xValue, yValue);
    newheight = yValue -oldY;
    console.log("newheight:" + newheight + "newX:" + newX + "newy:" + newY);
} 

function fnShownPopup(s, e) {
    //if (bClosedUsingButton == false) {
    //    //change status of file
    //    var streditInfo = $('#editInfo').val();
    //    var strFolderPath = $('#strFolderPath').val();
    //    console.log("1");
    //    var wholeData = JSON.stringify({ 'id': streditInfo });
    //    console.log("2");
    //    $.ajax({
    //        type: 'POST',
    //        url: `/Home/fnChangeDocumentSatus`,
    //        contentType: 'application/json; charset=utf-8',
    //        dataType: 'json',
    //        data: wholeData,
    //        success: function (data) {
    //            if (data.result == true) {
    //                console.log("3");
    //                try {
    //                    //show document is in edit mode
    //                    var p1 = strFolderPath;
    //                    var p = p1.replace(/\\/g, "/");
    //                    if (p.charAt(0) == '/') {
    //                        p = p.substr(1);
    //                    }
    //                    console.log("4");
    //                    fnSendWsUpdate(p);
    //                } catch (e) {
    //                }
    //            }
    //            else
    //            {
    //                console.log("fnClosePDfDocument data.result false ");
    //                if (data.message != "") {
    //                    alert('Error fnChangeDocumentSatus: ' + data.message);
    //                }
    //            }
    //        },
    //        //call on ajax call failure
    //        error: function (xhr, textStatus, error) {
    //            console.log("fnClosePDfDocument");
    //            //alertModal('Error fnShownPopup fnChangeDocumentSatus: ', xhr, textStatus, error);
    //        }
    //    });
    //}
}

function detectIE() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf('MSIE ');
    if (msie > 0) {
        return true;
    }
    var trident = ua.indexOf('Trident/');
    if (trident > 0) {
        // IE 11 => return version number
        var rv = ua.indexOf('rv:');
        return true;
    }
    var edge = ua.indexOf('Edge/');
    if (edge > 0) {
        return true;
    }
    // other browser
    return false;
}
function fnValidateEvent(s, e) {

}

function OnNameValidation() {
    var bReturnVal = "";
    //if (e.value == null)
    //    e.isValid = false;
  
    var name = textareaTest.GetText(); //String(e.value);   
    
    if (name.length > 200) {
        e.isValid = false;
        e.errorText = "Must be under 200 characters";
       // btnSave.SetEnabled(false);
    }
    else {
        var strname=name.trim("");       
        if (strname.length >= 1 && strname != null && strname != "null") {
            if (containsOnlySpaces(strname)) {
                //btnSave.SetEnabled(false);                
                bReturnVal = pdf_entertext_msg;              
            }
            else {
                /// btnSave.SetEnabled(true);
                bReturnVal = "valid";
            }
        }
        else {    
           // btnSave.SetEnabled(false);
            bReturnVal = pdf_entertext_msg;
        }
    }
    return bReturnVal;
}
function onShowAddTextPopup(s, e) {
    //btnSave.SetEnabled(false);
    lblPolicyMessage.SetText("");
    lblPolicyMessage.SetVisible(false);
    textareaTest.SetFocus();      
}

function containsOnlySpaces(text) {
    // Use a regular expression to check if the text contains only spaces
    return /^\s*$/.test(text);
}
